import { StackFrame } from './stack-trace';
export type ErrorEventArgs = [
    event: string | Event,
    source?: string | undefined,
    lineno?: number | undefined,
    colno?: number | undefined,
    error?: Error | undefined
];
export interface ErrorProperties {
    $exception_type: string;
    $exception_message: string;
    $exception_source?: string;
    $exception_lineno?: number;
    $exception_colno?: number;
    $exception_DOMException_code?: string;
    $exception_is_synthetic?: boolean;
    $exception_stack_trace_raw?: string;
    $exception_handled?: boolean;
    $exception_personURL?: string;
}
export declare function parseStackFrames(ex: Error & {
    framesToPop?: number;
    stacktrace?: string;
}): StackFrame[];
export declare function errorToProperties([event, source, lineno, colno, error]: ErrorEventArgs): ErrorProperties;
export declare function unhandledRejectionToProperties([ev]: [ev: PromiseRejectionEvent]): ErrorProperties;
