import { BasicSurveyQuestion, SurveyAppearance, LinkSurveyQuestion, RatingSurveyQuestion, MultipleSurveyQuestion } from '../../../posthog-surveys-types';
export declare function OpenTextQuestion({ question, appearance, onSubmit, }: {
    question: BasicSurveyQuestion;
    appearance: SurveyAppearance;
    onSubmit: (text: string) => void;
}): JSX.Element;
export declare function LinkQuestion({ question, appearance, onSubmit, }: {
    question: LinkSurveyQuestion;
    appearance: SurveyAppearance;
    onSubmit: (clicked: string) => void;
}): JSX.Element;
export declare function RatingQuestion({ question, displayQuestionIndex, appearance, onSubmit, }: {
    question: RatingSurveyQuestion;
    displayQuestionIndex: number;
    appearance: SurveyAppearance;
    onSubmit: (rating: number | null) => void;
}): JSX.Element;
export declare function RatingButton({ num, active, displayQuestionIndex, appearance, setActiveNumber, }: {
    num: number;
    active: boolean;
    displayQuestionIndex: number;
    appearance: any;
    setActiveNumber: (num: number) => void;
}): JSX.Element;
export declare function MultipleChoiceQuestion({ question, displayQuestionIndex, appearance, onSubmit, }: {
    question: MultipleSurveyQuestion;
    displayQuestionIndex: number;
    appearance: SurveyAppearance;
    onSubmit: (choices: string | string[] | null) => void;
}): JSX.Element;
