import { PostHog } from './posthog-core';
import { SurveyCallback, SurveyUrlMatchType } from './posthog-surveys-types';
import { SurveyEventReceiver } from './utils/survey-event-receiver';
import { DecideResponse } from './types';
export declare const surveyUrlValidationMap: Record<SurveyUrlMatchType, (conditionsUrl: string) => boolean>;
export declare class PostHogSurveys {
    instance: PostHog;
    private _decideServerResponse?;
    _surveyEventReceiver: SurveyEventReceiver | null;
    constructor(instance: PostHog);
    afterDecideResponse(response: DecideResponse): void;
    loadIfEnabled(): void;
    getSurveys(callback: SurveyCallback, forceReload?: boolean): void;
    getActiveMatchingSurveys(callback: SurveyCallback, forceReload?: boolean): void;
}
