import { SurveyContext, defaultSurveyAppearance } from '../surveys-utils';
import { cancelSVG } from '../icons';
import { useContext } from 'preact/hooks';
export function QuestionHeader(_a) {
    var question = _a.question, description = _a.description, backgroundColor = _a.backgroundColor;
    return (<div style={{ backgroundColor: backgroundColor || defaultSurveyAppearance.backgroundColor }}>
            <div className="survey-question">{question}</div>
            {description && <div className="description" dangerouslySetInnerHTML={{ __html: description }}/>}
        </div>);
}
export function Cancel(_a) {
    var onClick = _a.onClick;
    var isPreviewMode = useContext(SurveyContext).isPreviewMode;
    return (<div className="cancel-btn-wrapper">
            <button className="form-cancel" onClick={onClick} disabled={isPreviewMode}>
                {cancelSVG}
            </button>
        </div>);
}
//# sourceMappingURL=QuestionHeader.jsx.map